import gensim

from segmentation.segmentationmodel import SegmentationModel
from util.page import Page


class GensimModel(SegmentationModel):

    # Overrides
    def predict(self, page1: Page, page2: Page) -> float:
        token1 = gensim.utils.simple_preprocess(page1.text, min_len=4, max_len=100)
        token2 = gensim.utils.simple_preprocess(page2.text, min_len=4, max_len=100)
        if len(token1) > 1 or len(token2) > 1:
            similar_doc = 1 - gensim.matutils.jaccard(token1, token2)
            return similar_doc
        return 0
