import numpy
from sklearn.metrics import confusion_matrix, average_precision_score, classification_report

# from imageclassification.resnet import get_new_model, get_saved_model
from util.datasets import txt_to_pages, get_dataset_classify, get_pages

# loc = "C:/Users/rolv_/Documents/RVL-CDIP/"
loc = "D:/braArkivUttrekk/Klepp100k/%s.png"

# test = txt_to_pages(loc + "labels/test.txt", loc + "images/%s")
pages = get_pages("../res/Klepp100k_cleaned.csv", loc)

test = pages[4 * len(pages) // 5:]

classes = {v: k for k, v in dict(enumerate(sorted({p.true_class.strip().lower() for p in pages}))).items()}
print(classes)

# model = get_new_model(len(classes), 512, 362,
#                       dense=None,
#                       pooling='avg',
#                       weights=None,
#                       lr=1e-5)

# model = get_saved_model("../res/resnet-models/ResNet-Klepp-(512,362)-avg-None-general.hdf5", model)
#
# batch = 1
# test_data = get_dataset_classify(test, classes, batch, 512, 362, 3)
#
# pred = model.predict(test_data, verbose=1, steps=len(test) // batch)
#
# numpy.save("preds.npy", pred)
pred = numpy.load("preds-KleppL.npy")

print(pred.shape)

print(confusion_matrix(numpy.array([classes[p.true_class.strip().lower()] for p in test]), numpy.argmax(pred, -1), labels=list(range(len(classes)))))
print(classification_report(numpy.array([classes[p.true_class.strip().lower()] for p in test]), numpy.argmax(pred, -1)))

"""
RVL-CDIP:
[[2221   27   14   31   19    9    6    4   13    6    6   20   41   24     1   22]
 [  62 1998    3   27   26   39    5   33   18   11   31  129   17   81     3   23]
 [  13    5 2461    0    2    6    1    3    5    1    1    1    6    5     2    4]
 [  14   25    1 2382   29    1    3    9    3    1    0   11    4   49     0    0]
 [   9    8    1   10 2299    4   15    2   17   73   10    4   29   30     0    4]
 [  29   89    0    2   12 1833   71   22   31   18   55   19  244   34    21   18]
 [   0    6    0    0    9   52 2377    4   34   54    0    1   27    5     0    3]
 [  17   71    4   10    9   40    8 2217    2    8   18   22   12   31     1    2]
 [   1    2    1    2   13    8    3    1 2452    2    6    0   30    4     1    1]
 [  11    1    2    0   31   18   27    0   10 2252    8    0   91    2     4    6]
 [  10   34    0    3   11   60    5    7   25   16 2185   57   70   17     2    3]
 [  28   69    1   15    6    8    1    2   12    3   35 2273    6   14     0    4]
 [   9   10    2    0   21   95   20    1   51   34   54    2 2144   20    16   10]
 [  32   47    0   18   34   24    8   11   18    9   21    6   66 2131     3    7]
 [  11    8    1    1    5   15    8    1    3   14    5    3   47    4  2409    2]
 [  66   32    2    1    8   14    4    4   19    6   12    5   32    2     2 2283]]
 
 
Klepp:
[[9034  227    0 1659    0    0    0   49    0    0   19   347]
 [ 356  738    0  178    0    0    0   16    0    0    1    29]
 [   0    0    0    0    0    0    0    0    0    0    0     0]
 [ 342    7    0 1256    0    0    0  124    0    0    0     5]
 [  11    0    0    1    0    0    0    0    0    0    0     1]
 [   2    0    0   12    0    0    0    0    0    0    0     0]
 [   0    0    0    0    0    0    0    0    0    0    0     0]
 [2558  198    0  947    0    0    0 2375    0    0    1    80]
 [   0    0    0    0    0    0    0    0    0    0    0     0]
 [   0    0    0    0    0    0    0    0    0    0    0     0]
 [  85    8    0   11    0    0    0    2    0    0    0    19]
 [ 628   27    0  223    0    0    0    9    0    0    7  1041]]
"""
